<script>
import Vue from 'vue';
import {
  SlpContainer,
  SlpColumn,
  HorizontalScrollBar,
} from '../common/index.vue';
import ChevronLg from '~/static/nuxt-images/ico/chevron-lg.vue';

export default Vue.extend({
  components: {
    ChevronLg,
    SlpContainer,
    SlpColumn,
    HorizontalScrollBar,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      progress: 0,
    };
  },
  mounted() {
    const { cards } = this.$refs;
    cards.$el.addEventListener(
      'scroll',
      // eslint-disable-next-line func-names
      function (e) {
        const { clientWidth } = e.target;
        const { scrollLeft } = e.target;
        const { scrollWidth } = e.target;

        const scrollPercent = scrollLeft / (scrollWidth - clientWidth);
        const scrollPercentRounded = Math.round(scrollPercent * 100);
        this.progress = scrollPercentRounded;
      }.bind(this),
    );
  },
});
</script>

<template>
  <section>
    <SlpContainer>
      <SlpRow class="accolades-block__container">
        <div class="accolades-block__header">
          <SlpTypography tag="h2" variant="heading2">
            {{ data.header }}
          </SlpTypography>
          <SlpButton
            variant="tertiary"
            :href="data.link_url"
            :data-ga-name="data.data_ga_name"
            :data-ga-location="data.data_ga_location"
            >{{ data.link_text }}<ChevronLg fill="#171321" direction="right"
          /></SlpButton>
        </div>
        <hr class="accolades-block__hr" />
      </SlpRow>
      <SlpRow ref="cards" class="accolades-block__cards">
        <SlpColumn
          v-for="(accolade, index) in data.accolades"
          :key="index"
          class="slp-mb-48 card"
        >
          <a
            :href="accolade.link_url"
            class="accolades-block"
            :data-ga-name="accolade.data_ga_name"
            :data-ga-location="accolade.data_ga_location"
          >
            <div class="accolades-block__wrapper">
              <div class="accolades-block__content-top">
                <SlpTypography tag="h3" class="accolade-header">
                  <span>{{ accolade.header_action }}</span>
                  {{ accolade.header_content }}</SlpTypography
                >
              </div>
              <div class="accolades-block__content-middle">
                <SlpTypography tag="p">
                  {{ accolade.text }}
                </SlpTypography>
              </div>
              <div class="accolades-block__content-bottom">
                <SlpTypography
                  variant="button"
                  tag="p"
                  class="accolades-block__link"
                  >Learn more<ChevronLg fill="#171321" direction="right"
                /></SlpTypography>
              </div>
            </div>
          </a>
        </SlpColumn>
      </SlpRow>
      <HorizontalScrollBar class="horizontal-scroll" :value="progress" />
      <hr class="accolades-block__hr-bottom" />
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.horizontal-scroll {
  display: none;
}

.accolades-block__hr {
  border-top: 1px solid $color-surface-400;
  border-bottom: 0;
  border-left: 0;
  border-right: 0;
  width: 100%;

  &-bottom {
    margin-top: 30px;
    margin-bottom: 160px;
  }
}

.accolades-block__container {
  margin: 0 auto 30px auto;
}

.accolades-block__header {
  width: 100%;
  display: flex;
  flex-direction: row;
  justify-content: space-between;
  align-items: center;
  margin-bottom: 40px;

  h2 {
    font-weight: $font-weight-bold;
  }

  @media (max-width: 835px) {
    flex-direction: column;

    a {
      flex: 1 0 auto;
    }
  }
}

.slp-btn svg,
.resources-block__link svg {
  vertical-align: middle;
  margin-left: $spacing-4;
}

.accolades-block {
  cursor: pointer;
  display: flex;
  position: relative;
  min-height: 445px;
  height: 100%;
  flex-basis: 0;
  flex-grow: 1;

  @media (min-width: $breakpoint-md) {
    margin: $spacing-16 $spacing-16 $spacing-16 0;
  }

  &__wrapper {
    display: flex;
    flex-direction: column;
    transition: all 0.3s ease-in-out;
    justify-content: space-between;
    flex: 1;
    border-radius: 0px;
    padding: $spacing-32 $spacing-32 $spacing-48 $spacing-32;

    &:hover {
      background: $color-surface-800;
      border-radius: 0px 0px 100px 0px;
      box-shadow: $shadow-surface-primary-3;
    }
  }

  &__link {
    color: $color-text-300;
    padding-left: 0;
  }

  &__type {
    text-transform: uppercase;
    margin-left: $spacing-8;
    letter-spacing: 1px;
  }

  &__content-top {
    min-height: 120px;
    h3 {
      font-weight: $font-weight-bold;
      font-size: $text-heading-4;
      line-height: $line-height-heading-4;
      color: $color-text-300;

      span {
        text-transform: uppercase;
        font-size: $text-caps;
        line-height: $line-height-caps;
        color: $color-text-300;
        display: block;
        margin-bottom: $spacing-24;
      }
    }
  }

  &__content-middle {
    flex: 1 0 auto;
    margin-top: $spacing-24;

    p {
      color: $color-text-300;
      font-size: $font-size-default;
      line-height: $line-height-default;
    }
  }

  &__content-bottom p {
    display: flex;
    align-items: center;
    font-weight: $font-weight-bold;

    svg {
      margin-left: 8px;
      height: 18px;
    }
  }
}

@media (max-width: 835px) {
  .accolades-block {
    &__header {
      text-align: left;
      align-items: flex-start;

      .slp-btn {
        margin-top: $spacing-16;
        padding-left: 0;
      }
    }
  }
}

@media (max-width: 767px) {
  .horizontal-scroll {
    display: block;
  }

  .accolades-block__cards {
    overflow-x: auto;
    scrollbar-width: none; // hides scrollbar on Firefox
    -ms-overflow-style: none; // hides scrollbar on IE 10+

    &::-webkit-scrollbar {
      // hides scrollbar on browsers that use that use Webkit (Chrome, Safari, Opera, etc)
      width: 0;
      height: 0;
      display: none;
    }
    flex-wrap: nowrap !important;

    .card {
      min-width: 270px;
      background: $color-surface-800;

      &:not(:last-of-type) {
        margin-right: $spacing-16;
      }
    }
  }

  .accolades-block__hr-bottom {
    margin-top: 80px;
  }
}
</style>
